clc;
clear all;
close all;

[imgName, path] = uigetfile('../img/*.*', 'pick up 1 rgb image');
img = imread([path imgName]);

dim = size(img);
if length(dim) ==3
    img = rgb2gray(img);
end

%%%%%%%%%%%%%%
%%% RUMORE %%%
%%%%%%%%%%%%%%

I_SP = imnoise(img, 'salt & pepper', 0.3);
I_G = imnoise (img, 'gaussian', 0, 0.02);

%Filtro Media

w = fspecial('gaussian');
G_I = imfilter(double(img), w, 'conv','symmetric');
G_SP = imfilter(double(I_SP), w, 'conv','symmetric');
G_G = imfilter(double(I_G), w, 'conv','symmetric');

M_I = medfilt2(img, [3 3]);
M_SP = medfilt2(I_SP, [3 3]);
M_G = medfilt2(I_G, [3 3]);

figure('name', 'Image denoising with Gaussian or Median');
subplot(1,3,1);
imshow(img);
title('Original');

subplot(1,3,2);
imshow(G_I, [] );
title('Gaussian f.');

subplot(1,3,3);
imshow(M_I);
title('Median f.');
pause


subplot(1,3,1);
imshow(I_SP);
title('Salt and Pepper Noise');

subplot(1,3,2);
imshow(G_SP, []);
title('Gaussian f.');

subplot(1,3,3);
imshow(M_SP);
title('Median f.');
pause


subplot(1,3,1);
imshow(I_G);
title('Gaussian Noise');


subplot(1,3,2);
imshow(G_G, []);
title('Gaussian f.');

subplot(1,3,3);
imshow(M_G);
title('Median f.');
