% Inizializzazione
clc;
clear all;
close all;

[imgName, path] = uigetfile('../img/*.*', 'pick up 1 image');
img = imread([path imgName]);

dim = size(img);
if length(dim) ==3
    img = rgb2gray(img);
end

E_sobel = edge(img, 'sobel');
figure;
imshow(E_sobel, []);
title('Bordi con Sobel');
pause

figure('name', 'LoG using fspecial + imfilter + edge per lo zerocrossing');
subplot(2,4,1);
imshow(img);
title('img originale');
  

%Filtraggio lineare:

filtering_mode{1} =  'corr'; 
filtering_mode{2} =  'conv'; %default = 'corr'

boundary_options{1} = 0;
boundary_options{2} = 'replicate'; 
boundary_options{3} = 'symmetric'; 
boundary_options{4} = 'circular'; %default = 0
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FILTRO Lapalciano della Gaussian                       %%%
%%% usando fspecial + imfilter + edge per lo zerocrossing  %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

w = fspecial('log'); %, 5, 0.5); default values
g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3});
 
subplot(2,4,2);
imshow(g, []);
title('Params (default): ([5 5], sigma=0.5)');

subplot(2,4,3);
imshow(abs(g), []);
title('Abs');

E_ZC = edge (img, 'zerocross', [], w);
subplot(2,4,4);
imshow(E_ZC, []);
title('Zero crossing');
pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

w = fspecial('log', [13 13], 2.0);
g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3});
 
subplot(2,4,6);
imshow(g, []);
title('Params ([13 13], sigma=2)');

subplot(2,4,7);
imshow(abs(g), []);
title('Abs');

[E_ZC, thresh] = edge (img, 'zerocross', [], w);
subplot(2,4,8);
imshow(E_ZC, []);
title(['Zero crossing with automatic thresh: ' num2str(thresh)]);
pause 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%  FILTRO LoG usando la f. "edge"   %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure('name', 'LoG with the Edge function');
subplot(2,1,1);
BW = edge(img,'log',0);
imshow(BW, []);
title('sigma=2 (default); thresh=0');

subplot(2,1,2);
BW = edge(img,'log',0.01);
imshow(BW, []);
title('sigma=2 (default); thresh=0.01');
pause


%%%%%%%%%%%
%% CANNY %%
%%%%%%%%%%%

%BW = edge(I,method,threshold,direction,sigma) 
% threshold: 2 element vector [low high] ; []==> automatically computed
% (inspect the second output of the edge function
%direction: 'both' (default), 'horizontal', 'vertical'
%sigma: default: sqrt(2) 

figure('name', 'Canny edge detector'); 
sigmas = [0.5, 1. sqrt(2), 2];
for i = 1: length(sigmas)
    [E_canny thresh] = edge(img, 'canny', [], 'both', sigmas(i));
    subplot(2,2,i);
    imshow(E_canny);
    title(['Sigma ' num2str(sigmas(i))]); 
end



