% Inizializzazione
clc;
clear all;
close all;

[imgName, path] = uigetfile('../img/*.*', 'pick up 1 image');
img = imread([path imgName]);

figure;
imshow(img);
title('Immagine originale');

dim = size(img);
if length(dim) ==3
    img = rgb2gray(img);
end

%Filtraggio lineare:

filtering_mode{1} =  'corr'; 
filtering_mode{2} =  'conv'; %default = 'corr'


boundary_options{1} = 0;
boundary_options{2} = 'replicate'; 
boundary_options{3} = 'symmetric'; 
boundary_options{4} = 'circular'; %default = 0

figure('name', 'Smoothing with box filtering of different sizes:');

c=0;
for idx = 3:2:9
    c = c + 1;
    w = ones(idx);
    w = w/sum(w(:));
    g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3} );
    subplot(2,2,c);
    imshow(g, []);
    title(['w: ' num2str(idx) 'x' num2str(idx)]);
end
pause

%%FILTRI DI SMOOTHING

%Costruzione della maschera:
type{1} = 'average';
%parameters{1} = [r c]; %default = 3x3

type{2} = 'disk';
%parameters{2} = r; %default = 5 ; cerchio di raggio r inscritto in una maschera di dimensioni 2r+1

type{3} = 'gaussian';
%size = [r,c];
%parameters{3} = [size, sig]; %default = 3 x 3 . 0.5 


figure('name', 'Smoothing filtering with different filters:');
subplot(2,2,1);
imshow(img);
title('img originale');

for idx=1:3
    w = fspecial(type{idx});
    g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3});
    subplot(2,2,idx+1);
    imshow(g, []);
    title(type{idx});
end
pause

%FILTRI GAUSSIANI
r = [3, 5, 11];
sigma = [1, 4];
c = 0;
hMesh =  figure('name', 'Gaussian filter meshes');
hImgs =  figure('name', 'Images filtered by Gaussian filters with different sizes and sigmas');
for idxR = 1:3
    for idxS = 1:2
        c = c + 1;
        w = fspecial('gaussian', r(idxR), sigma(idxS));
        figure(hMesh);
        mesh(w);
        g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3});
        figure(hImgs);
        subplot(3,2,c);
        imshow(g, []);
        title(['Gaussiano. r = ' num2str(r(idxR)) 'sigma = ' num2str(sigma(idxS))]);
        figure(4);
        subplot(3,2,c);
        mesh(w);        
    end
end
pause

%%FILTRI DiI SHARPENING:

w = [0 -1 0; 
    -1 5 -1; 
    0 -1 0];
g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3});
figure('name', 'Sharpening');
subplot(2,1,1);
imshow(g, []);
title('Sum to 1');

w = fspecial('laplacian', 0);
g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3});
subplot(2,1,2);
imshow(g, []);
title('Sum to 0');
pause

%Filtraggio lineare:

filtering_mode{1} =  'corr'; 
filtering_mode{2} =  'conv'; %default = 'corr'

boundary_options{1} = 0;
boundary_options{2} = 'replicate'; 
boundary_options{3} = 'symmetric'; 
boundary_options{4} = 'circular'; %default = 0

size_options{1} = 'full'; 
size_options{2} ='same'; %default = 'same'
c= 0;

%%FILTRI DERIVATIVI:

type{1} = 'laplacian';
type{2} = 'log';
type{3} = 'prewitt';
type{4} = 'sobel';

w = fspecial(type{4});
w_t = w';
g = imfilter(double(img), w, filtering_mode{2}, boundary_options{3});
g_t = imfilter(double(img), w_t, filtering_mode{2}, boundary_options{3});

figure('name', 'Sobel fitering');
subplot(1,3,1);
imshow(abs(g), []);
title('Horizontal edges');

subplot(1,3,2);
imshow(abs(g_t), []);
title('Vertical edges');

g_mag = abs(g) + abs(g_t);
subplot(1,3,3);
imshow(g_mag, []);
title('Magnitude');
  





