function ExtremumSharpening (img, dimF)
 
if nargin<2
    dimF = 3;
end

if nargin<1
    [imgName, path] = uigetfile('../img/*.*', 'pick up 1 gray scale image');
    img = imread([path imgName]);
end
    
dim = size(img);
if length(dim) ==3
    img = double(rgb2gray(img));
end

img_ES = zeros(dim(1), dim(2));

raggio = floor(dimF/2);

imshow(img);
title('img originale');

for i= raggio+1: dim(1)- (raggio +1)
    for j= raggio+1: dim(2)- (raggio +1)
        w = img(i-raggio : i + raggio, j-raggio:j+ raggio);
        minW  = min(w(:));
        maxW  = max(w(:));
        if abs(img(i,j)-minW) <= abs(img(i,j)-maxW)
            img_ES(i,j) = minW;
        else
            img_ES(i,j) = maxW;
        end
    end
end
 
subplot(1,2,1);
imshow(img, []);
title('Img Originale');
 
subplot(1,2,2);
imshow(img_ES, []);
title(['Extremum Sharpening ' num2str(dimF) 'x' num2str(dimF)]);
