function ModifiedTrimmed (img, dimF, K)

% Inizializzazione
clc;
clear all;
close all;

if nargin<3  K = 10; end
if nargin<2  dimF = 5; end
if nargin<1 
    [imgName, path] = uigetfile('../img/*.*', 'pick up 1 gray scale image');
    img = imread([path imgName]);
end
   
 
dim = size(img);
if length(dim) ==3
    img = rgb2gray(img);
end

img_MT = zeros(dim(1), dim(2));

raggio = floor(dimF/2);

imshow(img);
title('img originale');

I_noise = imnoise (img, 'gaussian', 0.02);
I_noise = imnoise(I_noise, 'salt & pepper', 0.03);

Medians = medfilt2(I_noise, [dimF dimF]);

for i= raggio+1: dim(1)- (raggio +1)
    for j= raggio+1: dim(2)- (raggio +1)
        w = I_noise(i-raggio : i + raggio, j-raggio:j+ raggio);
        mask = abs(w - Medians(i,j))<= K;
        idx = find(mask);
        img_MT(i,j) = sum(w(idx))/sum(mask(:));
    end
end
 
subplot(1,2,1);
imshow(I_noise);
title('Img Rumorosa');
 
subplot(1,2,2);
imshow(img_MT, []);
title(['Modified Trimmed ' num2str(dimF) 'x' num2str(dimF) ',K=' num2str(K)]);
