function w = genlaplacian(n, type)
%GENLAPLACIAN with type = 'F': Generates a Laplacian mask of (odd) size n-by-n, with all -1 except in the center.
%GENLAPLACIAN with type = 'V': Generates a Laplacian mask of (odd) size n-by-n, with -1 in the central cross except in the center.

% Check validy of the input. (See Chapt 2 projects for functions
% isinteger and iseven
 
if type == 'F'
    % Generate the mask.
    w = -ones(n);
    w((n + 1)/2, (n + 1)/2) = (double(n)^2) - 1;
else
    center = (double(n) - 1) *2;
    w = zeros(n);
    w((n + 1)/2, :) = -1;
    w(: , (n + 1)/2) = -1;
    w((n + 1)/2, (n + 1)/2) = center;
end
