function maxMedian (img, dimF)
 
close all;

if nargin<2
    dimF = 5;
end

if nargin<1
    [imgName, path] = uigetfile('../img/*.*', 'pick up 1 gray scale image');
    img = imread([path imgName]);
end
    
dim = size(img);
if length(dim) ==3
    img = rgb2gray(img);
end

img_MM = zeros(dim(1), dim(2));

raggio = floor(dimF/2);

imshow(img);
title('img originale');

img = imnoise(img, 'salt & pepper', 0.1);

F{1} = zeros(dimF);
F{1}(raggio+1, :) = 1;
idx{1} = find(F{1});

F{2} = zeros(dimF);
F{2}(: , raggio+1) = 1;
idx{2} = find(F{2});

F{4} = eye(dimF);
idx{4} = find(F{4});

F{3} = imrotate(F{4}, 90);
idx{3} = find(F{3});

for i= raggio+1: dim(1)- (raggio +1)
    for j= raggio+1: dim(2)- (raggio +1)
        med = zeros(4,1);
        w = img(i-raggio : i + raggio, j-raggio:j+ raggio);
        for u=1:4
            med(u) = median(double(w(idx{u})));
        end
        img_MM(i,j) = max(med);
    end
end
 
subplot(3,1,1);
imshow(img);
title('Img Originale');

subplot(3,1,2);
imshow(medfilt2(img, [5 5]));
title('mediano 5x5');

subplot(3,1,3);
imshow(img_MM, []);
title(['MaxMedian ' num2str(dimF) 'x' num2str(dimF)]);
